/*
  File autogenerated by gengetopt version 2.23
  generated with the following command:
  gengetopt --file-name=herwigopts --unamed-opts --long-help --no-handle-version

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef FIX_UNUSED
#define FIX_UNUSED(X) (void) (X) /* avoid warnings for unused params */
#endif

#include <getopt.h>

#include "herwigopts.h"

const char *gengetopt_args_info_purpose = "Herwig is a multi-purpose Monte-Carlo event generator for particle physics. See\narXiv:0803.0883 for a detailed manual, or arXiv:1101.2599 for a more general\ndescription of the physics behind MC event generation.";

const char *gengetopt_args_info_usage = "Usage: " CMDLINE_PARSER_PACKAGE " (read|build|integrate|mergegrids|run) [OPTIONS]... [FILE]";

const char *gengetopt_args_info_versiontext = "";

const char *gengetopt_args_info_description = "One of the commands 'read', 'build', 'integrate', 'mergegrids' or 'run' is\nrequired:\n    read - reads an input file and creates a run file,\n    build - reads an input file and creates matrix elements,\n    integrate - integrate subprocesses after running `build',\n    mergegrids - combine integration grids from parallel adaption,\n    run  - reads a run file and generates events.";

const char *gengetopt_args_info_full_help[] = {
  "  -h, --help               Print help and exit",
  "      --full-help          Print help, including hidden options, and exit",
  "  -V, --version            Print version and exit",
  "\nEvent generation options:",
  "  -N, --numevents=LONG     Number of events to generate.",
  "  -s, --seed=INT           The random number generator seed.",
  "  -t, --tag=TAG            A tag to append to the run name.  (default=`')",
  "  -d, --debug=INT          Set the ThePEG debug level.",
  "  -D, --debug-fpe          Enable floating point exceptions.  (default=off)",
  "  -q, --quiet              Disable event counter.  (default=off)",
  "  -j, --jobs=INT           Number of jobs to run in parallel.",
  "  -x, --setupfile=FILE     An input file to modify run parameters.",
  "\nBuild and integration options:",
  "  -c, --cachedir=DIR       Matchbox cache directory.  (default=`Herwig-cache')",
  "  -z, --jobsize=NUMBER     The number of subprocesses to integrate per job\n                             (build only).",
  "  -y, --maxjobs=NUMBER     The maximum number of integration jobs to be created\n                             (build only).",
  "  -n, --jobid=NUMBER       Integrate the given integration job.",
  "  -x, --setupfile=FILE     An input file to modify run parameters.\n  -t, --tag=TAG            A tag to append to the run name  (default=`')",
  "\nRepository options:",
  "  -i, --append-read=PATH   Append a search path for the read command.",
  "  -I, --prepend-read=PATH  Prepend a search path for the read command.",
  "\nPlugin library options:",
  "  -l, --append=PATH        Append a search path for dynamically loaded\n                             libraries.",
  "  -L, --prepend=PATH       Prepend a search path for dynamically loaded\n                             libraries.",
  "\nUsage: Herwig init [OPTIONS] FILE\n    creates a new default repository (not useful for end users).\n",
  "\nAdvanced options:",
  "      --repo=FILE          Repository file to use.\n                             (default=`HerwigDefaults.rpo')",
  "      --noexitonerror      If set, ThePEG will not try to recover from\n                             failures, but will exit with a non-zero return\n                             code.  (default=off)",
  "      --resume             Try to resume execution from an earlier interrupted\n                             run.  (default=off)",
    0
};

static void
init_help_array(void)
{
  gengetopt_args_info_help[0] = gengetopt_args_info_full_help[0];
  gengetopt_args_info_help[1] = gengetopt_args_info_full_help[1];
  gengetopt_args_info_help[2] = gengetopt_args_info_full_help[2];
  gengetopt_args_info_help[3] = gengetopt_args_info_full_help[3];
  gengetopt_args_info_help[4] = gengetopt_args_info_full_help[4];
  gengetopt_args_info_help[5] = gengetopt_args_info_full_help[5];
  gengetopt_args_info_help[6] = gengetopt_args_info_full_help[6];
  gengetopt_args_info_help[7] = gengetopt_args_info_full_help[7];
  gengetopt_args_info_help[8] = gengetopt_args_info_full_help[8];
  gengetopt_args_info_help[9] = gengetopt_args_info_full_help[9];
  gengetopt_args_info_help[10] = gengetopt_args_info_full_help[10];
  gengetopt_args_info_help[11] = gengetopt_args_info_full_help[11];
  gengetopt_args_info_help[12] = gengetopt_args_info_full_help[12];
  gengetopt_args_info_help[13] = gengetopt_args_info_full_help[13];
  gengetopt_args_info_help[14] = gengetopt_args_info_full_help[14];
  gengetopt_args_info_help[15] = gengetopt_args_info_full_help[15];
  gengetopt_args_info_help[16] = gengetopt_args_info_full_help[16];
  gengetopt_args_info_help[17] = gengetopt_args_info_full_help[17];
  gengetopt_args_info_help[18] = gengetopt_args_info_full_help[18];
  gengetopt_args_info_help[19] = gengetopt_args_info_full_help[19];
  gengetopt_args_info_help[20] = gengetopt_args_info_full_help[20];
  gengetopt_args_info_help[21] = gengetopt_args_info_full_help[21];
  gengetopt_args_info_help[22] = gengetopt_args_info_full_help[22];
  gengetopt_args_info_help[23] = gengetopt_args_info_full_help[23];
  gengetopt_args_info_help[24] = gengetopt_args_info_full_help[24];
  gengetopt_args_info_help[25] = 0; 
  
}

const char *gengetopt_args_info_help[26];

typedef enum {ARG_NO
  , ARG_FLAG
  , ARG_STRING
  , ARG_INT
  , ARG_LONG
} cmdline_parser_arg_type;

static
void clear_given (struct gengetopt_args_info *args_info);
static
void clear_args (struct gengetopt_args_info *args_info);

static int
cmdline_parser_internal (int argc, char **argv, struct gengetopt_args_info *args_info,
                        struct cmdline_parser_params *params, const char *additional_error);

static int
cmdline_parser_required2 (struct gengetopt_args_info *args_info, const char *prog_name, const char *additional_error);

static char *
gengetopt_strdup (const char *s);

static
void clear_given (struct gengetopt_args_info *args_info)
{
  args_info->help_given = 0 ;
  args_info->full_help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->numevents_given = 0 ;
  args_info->seed_given = 0 ;
  args_info->tag_given = 0 ;
  args_info->debug_given = 0 ;
  args_info->debug_fpe_given = 0 ;
  args_info->quiet_given = 0 ;
  args_info->jobs_given = 0 ;
  args_info->setupfile_given = 0 ;
  args_info->cachedir_given = 0 ;
  args_info->jobsize_given = 0 ;
  args_info->maxjobs_given = 0 ;
  args_info->jobid_given = 0 ;
  args_info->append_read_given = 0 ;
  args_info->prepend_read_given = 0 ;
  args_info->append_given = 0 ;
  args_info->prepend_given = 0 ;
  args_info->repo_given = 0 ;
  args_info->noexitonerror_given = 0 ;
  args_info->resume_given = 0 ;
}

static
void clear_args (struct gengetopt_args_info *args_info)
{
  FIX_UNUSED (args_info);
  args_info->numevents_orig = NULL;
  args_info->seed_orig = NULL;
  args_info->tag_arg = gengetopt_strdup ("");
  args_info->tag_orig = NULL;
  args_info->debug_orig = NULL;
  args_info->debug_fpe_flag = 0;
  args_info->quiet_flag = 0;
  args_info->jobs_orig = NULL;
  args_info->setupfile_arg = NULL;
  args_info->setupfile_orig = NULL;
  args_info->cachedir_arg = gengetopt_strdup ("Herwig-cache");
  args_info->cachedir_orig = NULL;
  args_info->jobsize_orig = NULL;
  args_info->maxjobs_orig = NULL;
  args_info->jobid_arg = NULL;
  args_info->jobid_orig = NULL;
  args_info->append_read_arg = NULL;
  args_info->append_read_orig = NULL;
  args_info->prepend_read_arg = NULL;
  args_info->prepend_read_orig = NULL;
  args_info->append_arg = NULL;
  args_info->append_orig = NULL;
  args_info->prepend_arg = NULL;
  args_info->prepend_orig = NULL;
  args_info->repo_arg = gengetopt_strdup ("HerwigDefaults.rpo");
  args_info->repo_orig = NULL;
  args_info->noexitonerror_flag = 0;
  args_info->resume_flag = 0;
  
}

static
void init_args_info(struct gengetopt_args_info *args_info)
{

  init_help_array(); 
  args_info->help_help = gengetopt_args_info_full_help[0] ;
  args_info->full_help_help = gengetopt_args_info_full_help[1] ;
  args_info->version_help = gengetopt_args_info_full_help[2] ;
  args_info->numevents_help = gengetopt_args_info_full_help[4] ;
  args_info->seed_help = gengetopt_args_info_full_help[5] ;
  args_info->tag_help = gengetopt_args_info_full_help[6] ;
  args_info->debug_help = gengetopt_args_info_full_help[7] ;
  args_info->debug_fpe_help = gengetopt_args_info_full_help[8] ;
  args_info->quiet_help = gengetopt_args_info_full_help[9] ;
  args_info->jobs_help = gengetopt_args_info_full_help[10] ;
  args_info->setupfile_help = gengetopt_args_info_full_help[11] ;
  args_info->cachedir_help = gengetopt_args_info_full_help[13] ;
  args_info->jobsize_help = gengetopt_args_info_full_help[14] ;
  args_info->maxjobs_help = gengetopt_args_info_full_help[15] ;
  args_info->jobid_help = gengetopt_args_info_full_help[16] ;
  args_info->append_read_help = gengetopt_args_info_full_help[19] ;
  args_info->append_read_min = 0;
  args_info->append_read_max = 0;
  args_info->prepend_read_help = gengetopt_args_info_full_help[20] ;
  args_info->prepend_read_min = 0;
  args_info->prepend_read_max = 0;
  args_info->append_help = gengetopt_args_info_full_help[22] ;
  args_info->append_min = 0;
  args_info->append_max = 0;
  args_info->prepend_help = gengetopt_args_info_full_help[23] ;
  args_info->prepend_min = 0;
  args_info->prepend_max = 0;
  args_info->repo_help = gengetopt_args_info_full_help[26] ;
  args_info->noexitonerror_help = gengetopt_args_info_full_help[27] ;
  args_info->resume_help = gengetopt_args_info_full_help[28] ;
  
}

void
cmdline_parser_print_version (void)
{
  printf ("%s %s\n",
     (strlen(CMDLINE_PARSER_PACKAGE_NAME) ? CMDLINE_PARSER_PACKAGE_NAME : CMDLINE_PARSER_PACKAGE),
     CMDLINE_PARSER_VERSION);

  if (strlen(gengetopt_args_info_versiontext) > 0)
    printf("\n%s\n", gengetopt_args_info_versiontext);
}

static void print_help_common(void)
{
	size_t len_purpose = strlen(gengetopt_args_info_purpose);
	size_t len_usage = strlen(gengetopt_args_info_usage);

	if (len_usage > 0) {
		printf("%s\n", gengetopt_args_info_usage);
	}
	if (len_purpose > 0) {
		printf("%s\n", gengetopt_args_info_purpose);
	}

	if (len_usage || len_purpose) {
		printf("\n");
	}

	if (strlen(gengetopt_args_info_description) > 0) {
		printf("%s\n\n", gengetopt_args_info_description);
	}
}

void
cmdline_parser_print_help (void)
{
  int i = 0;
  print_help_common();
  while (gengetopt_args_info_help[i])
    printf("%s\n", gengetopt_args_info_help[i++]);
}

void
cmdline_parser_print_full_help (void)
{
  int i = 0;
  print_help_common();
  while (gengetopt_args_info_full_help[i])
    printf("%s\n", gengetopt_args_info_full_help[i++]);
}

void
cmdline_parser_init (struct gengetopt_args_info *args_info)
{
  clear_given (args_info);
  clear_args (args_info);
  init_args_info (args_info);

  args_info->inputs = 0;
  args_info->inputs_num = 0;
}

void
cmdline_parser_params_init(struct cmdline_parser_params *params)
{
  if (params)
    { 
      params->override = 0;
      params->initialize = 1;
      params->check_required = 1;
      params->check_ambiguity = 0;
      params->print_errors = 1;
    }
}

struct cmdline_parser_params *
cmdline_parser_params_create(void)
{
  struct cmdline_parser_params *params = 
    (struct cmdline_parser_params *)malloc(sizeof(struct cmdline_parser_params));
  cmdline_parser_params_init(params);  
  return params;
}

static void
free_string_field (char **s)
{
  if (*s)
    {
      free (*s);
      *s = 0;
    }
}

/** @brief generic value variable */
union generic_value {
    int int_arg;
    long long_arg;
    char *string_arg;
    const char *default_string_arg;
};

/** @brief holds temporary values for multiple options */
struct generic_list
{
  union generic_value arg;
  char *orig;
  struct generic_list *next;
};

/**
 * @brief add a node at the head of the list 
 */
static void add_node(struct generic_list **list) {
  struct generic_list *new_node = (struct generic_list *) malloc (sizeof (struct generic_list));
  new_node->next = *list;
  *list = new_node;
  new_node->arg.string_arg = 0;
  new_node->orig = 0;
}


static void
free_multiple_string_field(unsigned int len, char ***arg, char ***orig)
{
  unsigned int i;
  if (*arg) {
    for (i = 0; i < len; ++i)
      {
        free_string_field(&((*arg)[i]));
        free_string_field(&((*orig)[i]));
      }
    free_string_field(&((*arg)[0])); /* free default string */

    free (*arg);
    *arg = 0;
    free (*orig);
    *orig = 0;
  }
}

static void
cmdline_parser_release (struct gengetopt_args_info *args_info)
{
  unsigned int i;
  free_string_field (&(args_info->numevents_orig));
  free_string_field (&(args_info->seed_orig));
  free_string_field (&(args_info->tag_arg));
  free_string_field (&(args_info->tag_orig));
  free_string_field (&(args_info->debug_orig));
  free_string_field (&(args_info->jobs_orig));
  free_string_field (&(args_info->setupfile_arg));
  free_string_field (&(args_info->setupfile_orig));
  free_string_field (&(args_info->cachedir_arg));
  free_string_field (&(args_info->cachedir_orig));
  free_string_field (&(args_info->jobsize_orig));
  free_string_field (&(args_info->maxjobs_orig));
  free_string_field (&(args_info->jobid_arg));
  free_string_field (&(args_info->jobid_orig));
  free_multiple_string_field (args_info->append_read_given, &(args_info->append_read_arg), &(args_info->append_read_orig));
  free_multiple_string_field (args_info->prepend_read_given, &(args_info->prepend_read_arg), &(args_info->prepend_read_orig));
  free_multiple_string_field (args_info->append_given, &(args_info->append_arg), &(args_info->append_orig));
  free_multiple_string_field (args_info->prepend_given, &(args_info->prepend_arg), &(args_info->prepend_orig));
  free_string_field (&(args_info->repo_arg));
  free_string_field (&(args_info->repo_orig));
  
  
  for (i = 0; i < args_info->inputs_num; ++i)
    free (args_info->inputs [i]);

  if (args_info->inputs_num)
    free (args_info->inputs);

  clear_given (args_info);
}


static void
write_into_file(FILE *outfile, const char *opt, const char *arg, const char *values[])
{
  FIX_UNUSED (values);
  if (arg) {
    fprintf(outfile, "%s=\"%s\"\n", opt, arg);
  } else {
    fprintf(outfile, "%s\n", opt);
  }
}

static void
write_multiple_into_file(FILE *outfile, int len, const char *opt, char **arg, const char *values[])
{
  int i;
  
  for (i = 0; i < len; ++i)
    write_into_file(outfile, opt, (arg ? arg[i] : 0), values);
}

int
cmdline_parser_dump(FILE *outfile, struct gengetopt_args_info *args_info)
{
  int i = 0;

  if (!outfile)
    {
      fprintf (stderr, "%s: cannot dump options to stream\n", CMDLINE_PARSER_PACKAGE);
      return EXIT_FAILURE;
    }

  if (args_info->help_given)
    write_into_file(outfile, "help", 0, 0 );
  if (args_info->full_help_given)
    write_into_file(outfile, "full-help", 0, 0 );
  if (args_info->version_given)
    write_into_file(outfile, "version", 0, 0 );
  if (args_info->numevents_given)
    write_into_file(outfile, "numevents", args_info->numevents_orig, 0);
  if (args_info->seed_given)
    write_into_file(outfile, "seed", args_info->seed_orig, 0);
  if (args_info->tag_given)
    write_into_file(outfile, "tag", args_info->tag_orig, 0);
  if (args_info->debug_given)
    write_into_file(outfile, "debug", args_info->debug_orig, 0);
  if (args_info->debug_fpe_given)
    write_into_file(outfile, "debug-fpe", 0, 0 );
  if (args_info->quiet_given)
    write_into_file(outfile, "quiet", 0, 0 );
  if (args_info->jobs_given)
    write_into_file(outfile, "jobs", args_info->jobs_orig, 0);
  if (args_info->setupfile_given)
    write_into_file(outfile, "setupfile", args_info->setupfile_orig, 0);
  if (args_info->cachedir_given)
    write_into_file(outfile, "cachedir", args_info->cachedir_orig, 0);
  if (args_info->jobsize_given)
    write_into_file(outfile, "jobsize", args_info->jobsize_orig, 0);
  if (args_info->maxjobs_given)
    write_into_file(outfile, "maxjobs", args_info->maxjobs_orig, 0);
  if (args_info->jobid_given)
    write_into_file(outfile, "jobid", args_info->jobid_orig, 0);
  write_multiple_into_file(outfile, args_info->append_read_given, "append-read", args_info->append_read_orig, 0);
  write_multiple_into_file(outfile, args_info->prepend_read_given, "prepend-read", args_info->prepend_read_orig, 0);
  write_multiple_into_file(outfile, args_info->append_given, "append", args_info->append_orig, 0);
  write_multiple_into_file(outfile, args_info->prepend_given, "prepend", args_info->prepend_orig, 0);
  if (args_info->repo_given)
    write_into_file(outfile, "repo", args_info->repo_orig, 0);
  if (args_info->noexitonerror_given)
    write_into_file(outfile, "noexitonerror", 0, 0 );
  if (args_info->resume_given)
    write_into_file(outfile, "resume", 0, 0 );
  

  i = EXIT_SUCCESS;
  return i;
}

int
cmdline_parser_file_save(const char *filename, struct gengetopt_args_info *args_info)
{
  FILE *outfile;
  int i = 0;

  outfile = fopen(filename, "w");

  if (!outfile)
    {
      fprintf (stderr, "%s: cannot open file for writing: %s\n", CMDLINE_PARSER_PACKAGE, filename);
      return EXIT_FAILURE;
    }

  i = cmdline_parser_dump(outfile, args_info);
  fclose (outfile);

  return i;
}

void
cmdline_parser_free (struct gengetopt_args_info *args_info)
{
  cmdline_parser_release (args_info);
}

/** @brief replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = 0;
  if (!s)
    return result;

  result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

static char *
get_multiple_arg_token(const char *arg)
{
  const char *tok;
  char *ret;
  size_t len, num_of_escape, i, j;

  if (!arg)
    return 0;

  tok = strchr (arg, ',');
  num_of_escape = 0;

  /* make sure it is not escaped */
  while (tok)
    {
      if (*(tok-1) == '\\')
        {
          /* find the next one */
          tok = strchr (tok+1, ',');
          ++num_of_escape;
        }
      else
        break;
    }

  if (tok)
    len = (size_t)(tok - arg + 1);
  else
    len = strlen (arg) + 1;

  len -= num_of_escape;

  ret = (char *) malloc (len);

  i = 0;
  j = 0;
  while (arg[i] && (j < len-1))
    {
      if (arg[i] == '\\' && 
	  arg[ i + 1 ] && 
	  arg[ i + 1 ] == ',')
        ++i;

      ret[j++] = arg[i++];
    }

  ret[len-1] = '\0';

  return ret;
}

static const char *
get_multiple_arg_token_next(const char *arg)
{
  const char *tok;

  if (!arg)
    return 0;

  tok = strchr (arg, ',');

  /* make sure it is not escaped */
  while (tok)
    {
      if (*(tok-1) == '\\')
        {
          /* find the next one */
          tok = strchr (tok+1, ',');
        }
      else
        break;
    }

  if (! tok || strlen(tok) == 1)
    return 0;

  return tok+1;
}

static int
check_multiple_option_occurrences(const char *prog_name, unsigned int option_given, unsigned int min, unsigned int max, const char *option_desc);

int
check_multiple_option_occurrences(const char *prog_name, unsigned int option_given, unsigned int min, unsigned int max, const char *option_desc)
{
  int error_occurred = 0;

  if (option_given && (min > 0 || max > 0))
    {
      if (min > 0 && max > 0)
        {
          if (min == max)
            {
              /* specific occurrences */
              if (option_given != (unsigned int) min)
                {
                  fprintf (stderr, "%s: %s option occurrences must be %d\n",
                    prog_name, option_desc, min);
                  error_occurred = 1;
                }
            }
          else if (option_given < (unsigned int) min
                || option_given > (unsigned int) max)
            {
              /* range occurrences */
              fprintf (stderr, "%s: %s option occurrences must be between %d and %d\n",
                prog_name, option_desc, min, max);
              error_occurred = 1;
            }
        }
      else if (min > 0)
        {
          /* at least check */
          if (option_given < min)
            {
              fprintf (stderr, "%s: %s option occurrences must be at least %d\n",
                prog_name, option_desc, min);
              error_occurred = 1;
            }
        }
      else if (max > 0)
        {
          /* at most check */
          if (option_given > max)
            {
              fprintf (stderr, "%s: %s option occurrences must be at most %d\n",
                prog_name, option_desc, max);
              error_occurred = 1;
            }
        }
    }
    
  return error_occurred;
}
int
cmdline_parser (int argc, char **argv, struct gengetopt_args_info *args_info)
{
  return cmdline_parser2 (argc, argv, args_info, 0, 1, 1);
}

int
cmdline_parser_ext (int argc, char **argv, struct gengetopt_args_info *args_info,
                   struct cmdline_parser_params *params)
{
  int result;
  result = cmdline_parser_internal (argc, argv, args_info, params, 0);

  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser2 (int argc, char **argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required)
{
  int result;
  struct cmdline_parser_params params;
  
  params.override = override;
  params.initialize = initialize;
  params.check_required = check_required;
  params.check_ambiguity = 0;
  params.print_errors = 1;

  result = cmdline_parser_internal (argc, argv, args_info, &params, 0);

  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser_required (struct gengetopt_args_info *args_info, const char *prog_name)
{
  int result = EXIT_SUCCESS;

  if (cmdline_parser_required2(args_info, prog_name, 0) > 0)
    result = EXIT_FAILURE;

  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser_required2 (struct gengetopt_args_info *args_info, const char *prog_name, const char *additional_error)
{
  int error_occurred = 0;
  FIX_UNUSED (additional_error);

  /* checks for required options */
  if (check_multiple_option_occurrences(prog_name, args_info->append_read_given, args_info->append_read_min, args_info->append_read_max, "'--append-read' ('-i')"))
     error_occurred = 1;
  
  if (check_multiple_option_occurrences(prog_name, args_info->prepend_read_given, args_info->prepend_read_min, args_info->prepend_read_max, "'--prepend-read' ('-I')"))
     error_occurred = 1;
  
  if (check_multiple_option_occurrences(prog_name, args_info->append_given, args_info->append_min, args_info->append_max, "'--append' ('-l')"))
     error_occurred = 1;
  
  if (check_multiple_option_occurrences(prog_name, args_info->prepend_given, args_info->prepend_min, args_info->prepend_max, "'--prepend' ('-L')"))
     error_occurred = 1;
  
  
  /* checks for dependences among options */

  return error_occurred;
}


static char *package_name = 0;

/**
 * @brief updates an option
 * @param field the generic pointer to the field to update
 * @param orig_field the pointer to the orig field
 * @param field_given the pointer to the number of occurrence of this option
 * @param prev_given the pointer to the number of occurrence already seen
 * @param value the argument for this option (if null no arg was specified)
 * @param possible_values the possible values for this option (if specified)
 * @param default_value the default value (in case the option only accepts fixed values)
 * @param arg_type the type of this option
 * @param check_ambiguity @see cmdline_parser_params.check_ambiguity
 * @param override @see cmdline_parser_params.override
 * @param no_free whether to free a possible previous value
 * @param multiple_option whether this is a multiple option
 * @param long_opt the corresponding long option
 * @param short_opt the corresponding short option (or '-' if none)
 * @param additional_error possible further error specification
 */
static
int update_arg(void *field, char **orig_field,
               unsigned int *field_given, unsigned int *prev_given, 
               char *value, const char *possible_values[],
               const char *default_value,
               cmdline_parser_arg_type arg_type,
               int check_ambiguity, int override,
               int no_free, int multiple_option,
               const char *long_opt, char short_opt,
               const char *additional_error)
{
  char *stop_char = 0;
  const char *val = value;
  int found;
  char **string_field;
  FIX_UNUSED (field);

  stop_char = 0;
  found = 0;

  if (!multiple_option && prev_given && (*prev_given || (check_ambiguity && *field_given)))
    {
      if (short_opt != '-')
        fprintf (stderr, "%s: `--%s' (`-%c') option given more than once%s\n", 
               package_name, long_opt, short_opt,
               (additional_error ? additional_error : ""));
      else
        fprintf (stderr, "%s: `--%s' option given more than once%s\n", 
               package_name, long_opt,
               (additional_error ? additional_error : ""));
      return 1; /* failure */
    }

  FIX_UNUSED (default_value);
    
  if (field_given && *field_given && ! override)
    return 0;
  if (prev_given)
    (*prev_given)++;
  if (field_given)
    (*field_given)++;
  if (possible_values)
    val = possible_values[found];

  switch(arg_type) {
  case ARG_FLAG:
    *((int *)field) = !*((int *)field);
    break;
  case ARG_INT:
    if (val) *((int *)field) = strtol (val, &stop_char, 0);
    break;
  case ARG_LONG:
    if (val) *((long *)field) = (long)strtol (val, &stop_char, 0);
    break;
  case ARG_STRING:
    if (val) {
      string_field = (char **)field;
      if (!no_free && *string_field)
        free (*string_field); /* free previous string */
      *string_field = gengetopt_strdup (val);
    }
    break;
  default:
    break;
  };

  /* check numeric conversion */
  switch(arg_type) {
  case ARG_INT:
  case ARG_LONG:
    if (val && !(stop_char && *stop_char == '\0')) {
      fprintf(stderr, "%s: invalid numeric value: %s\n", package_name, val);
      return 1; /* failure */
    }
    break;
  default:
    ;
  };

  /* store the original value */
  switch(arg_type) {
  case ARG_NO:
  case ARG_FLAG:
    break;
  default:
    if (value && orig_field) {
      if (no_free) {
        *orig_field = value;
      } else {
        if (*orig_field)
          free (*orig_field); /* free previous string */
        *orig_field = gengetopt_strdup (value);
      }
    }
  };

  return 0; /* OK */
}

/**
 * @brief store information about a multiple option in a temporary list
 * @param list where to (temporarily) store multiple options
 */
static
int update_multiple_arg_temp(struct generic_list **list,
               unsigned int *prev_given, const char *val,
               const char *possible_values[], const char *default_value,
               cmdline_parser_arg_type arg_type,
               const char *long_opt, char short_opt,
               const char *additional_error)
{
  /* store single arguments */
  char *multi_token;
  const char *multi_next;

  if (arg_type == ARG_NO) {
    (*prev_given)++;
    return 0; /* OK */
  }

  multi_token = get_multiple_arg_token(val);
  multi_next = get_multiple_arg_token_next (val);

  while (1)
    {
      add_node (list);
      if (update_arg((void *)&((*list)->arg), &((*list)->orig), 0,
          prev_given, multi_token, possible_values, default_value, 
          arg_type, 0, 1, 1, 1, long_opt, short_opt, additional_error)) {
        if (multi_token) free(multi_token);
        return 1; /* failure */
      }

      if (multi_next)
        {
          multi_token = get_multiple_arg_token(multi_next);
          multi_next = get_multiple_arg_token_next (multi_next);
        }
      else
        break;
    }

  return 0; /* OK */
}

/**
 * @brief free the passed list (including possible string argument)
 */
static
void free_list(struct generic_list *list, short string_arg)
{
  if (list) {
    struct generic_list *tmp;
    while (list)
      {
        tmp = list;
        if (string_arg && list->arg.string_arg)
          free (list->arg.string_arg);
        if (list->orig)
          free (list->orig);
        list = list->next;
        free (tmp);
      }
  }
}

/**
 * @brief updates a multiple option starting from the passed list
 */
static
void update_multiple_arg(void *field, char ***orig_field,
               unsigned int field_given, unsigned int prev_given, union generic_value *default_value,
               cmdline_parser_arg_type arg_type,
               struct generic_list *list)
{
  int i;
  struct generic_list *tmp;

  if (prev_given && list) {
    *orig_field = (char **) realloc (*orig_field, (field_given + prev_given) * sizeof (char *));

    switch(arg_type) {
    case ARG_INT:
      *((int **)field) = (int *)realloc (*((int **)field), (field_given + prev_given) * sizeof (int)); break;
    case ARG_LONG:
      *((long **)field) = (long *)realloc (*((long **)field), (field_given + prev_given) * sizeof (long)); break;
    case ARG_STRING:
      *((char ***)field) = (char **)realloc (*((char ***)field), (field_given + prev_given) * sizeof (char *)); break;
    default:
      break;
    };
    
    for (i = (prev_given - 1); i >= 0; --i)
      {
        tmp = list;
        
        switch(arg_type) {
        case ARG_INT:
          (*((int **)field))[i + field_given] = tmp->arg.int_arg; break;
        case ARG_LONG:
          (*((long **)field))[i + field_given] = tmp->arg.long_arg; break;
        case ARG_STRING:
          (*((char ***)field))[i + field_given] = tmp->arg.string_arg; break;
        default:
          break;
        }        
        (*orig_field) [i + field_given] = list->orig;
        list = list->next;
        free (tmp);
      }
  } else { /* set the default value */
    if (default_value && ! field_given) {
      switch(arg_type) {
      case ARG_INT:
        if (! *((int **)field)) {
          *((int **)field) = (int *)malloc (sizeof (int));
          (*((int **)field))[0] = default_value->int_arg; 
        }
        break;
      case ARG_LONG:
        if (! *((long **)field)) {
          *((long **)field) = (long *)malloc (sizeof (long));
          (*((long **)field))[0] = default_value->long_arg;
        }
        break;
      case ARG_STRING:
        if (! *((char ***)field)) {
          *((char ***)field) = (char **)malloc (sizeof (char *));
          (*((char ***)field))[0] = gengetopt_strdup(default_value->string_arg);
        }
        break;
      default: break;
      }
      if (!(*orig_field)) {
        *orig_field = (char **) malloc (sizeof (char *));
        (*orig_field)[0] = 0;
      }
    }
  }
}

int
cmdline_parser_internal (
  int argc, char **argv, struct gengetopt_args_info *args_info,
                        struct cmdline_parser_params *params, const char *additional_error)
{
  int c;	/* Character of the parsed option.  */

  struct generic_list * append_read_list = NULL;
  struct generic_list * prepend_read_list = NULL;
  struct generic_list * append_list = NULL;
  struct generic_list * prepend_list = NULL;
  int error_occurred = 0;
  struct gengetopt_args_info local_args_info;
  
  int override;
  int initialize;
  int check_required;
  int check_ambiguity;
  
  package_name = argv[0];
  
  /* TODO: Why is this here? It is not used anywhere. */
  override = params->override;
  FIX_UNUSED(override);

  initialize = params->initialize;
  check_required = params->check_required;

  /* TODO: Why is this here? It is not used anywhere. */
  check_ambiguity = params->check_ambiguity;
  FIX_UNUSED(check_ambiguity);

  if (initialize)
    cmdline_parser_init (args_info);

  cmdline_parser_init (&local_args_info);

  optarg = 0;
  optind = 0;
  opterr = params->print_errors;
  optopt = '?';

  while (1)
    {
      int option_index = 0;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "full-help",	0, NULL, 0 },
        { "version",	0, NULL, 'V' },
        { "numevents",	1, NULL, 'N' },
        { "seed",	1, NULL, 's' },
        { "tag",	1, NULL, 't' },
        { "debug",	1, NULL, 'd' },
        { "debug-fpe",	0, NULL, 'D' },
        { "quiet",	0, NULL, 'q' },
        { "jobs",	1, NULL, 'j' },
        { "setupfile",	1, NULL, 'x' },
        { "cachedir",	1, NULL, 'c' },
        { "jobsize",	1, NULL, 'z' },
        { "maxjobs",	1, NULL, 'y' },
        { "jobid",	1, NULL, 'n' },
        { "append-read",	1, NULL, 'i' },
        { "prepend-read",	1, NULL, 'I' },
        { "append",	1, NULL, 'l' },
        { "prepend",	1, NULL, 'L' },
        { "repo",	1, NULL, 0 },
        { "noexitonerror",	0, NULL, 0 },
        { "resume",	0, NULL, 0 },
        { 0,  0, 0, 0 }
      };

      c = getopt_long (argc, argv, "hVN:s:t:d:Dqj:x:c:z:y:n:i:I:l:L:", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          cmdline_parser_print_help ();
          cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
        
        
          if (update_arg( 0 , 
               0 , &(args_info->version_given),
              &(local_args_info.version_given), optarg, 0, 0, ARG_NO,
              check_ambiguity, override, 0, 0,
              "version", 'V',
              additional_error))
            goto failure;
          cmdline_parser_free (&local_args_info);
          return 0;
        
          break;
        case 'N':	/* Number of events to generate..  */
        
        
          if (update_arg( (void *)&(args_info->numevents_arg), 
               &(args_info->numevents_orig), &(args_info->numevents_given),
              &(local_args_info.numevents_given), optarg, 0, 0, ARG_LONG,
              check_ambiguity, override, 0, 0,
              "numevents", 'N',
              additional_error))
            goto failure;
        
          break;
        case 's':	/* The random number generator seed..  */
        
        
          if (update_arg( (void *)&(args_info->seed_arg), 
               &(args_info->seed_orig), &(args_info->seed_given),
              &(local_args_info.seed_given), optarg, 0, 0, ARG_INT,
              check_ambiguity, override, 0, 0,
              "seed", 's',
              additional_error))
            goto failure;
        
          break;
        case 't':	/* A tag to append to the run name..  */
        
        
          if (update_arg( (void *)&(args_info->tag_arg), 
               &(args_info->tag_orig), &(args_info->tag_given),
              &(local_args_info.tag_given), optarg, 0, "", ARG_STRING,
              check_ambiguity, override, 0, 0,
              "tag", 't',
              additional_error))
            goto failure;
        
          break;
        case 'd':	/* Set the ThePEG debug level..  */
        
        
          if (update_arg( (void *)&(args_info->debug_arg), 
               &(args_info->debug_orig), &(args_info->debug_given),
              &(local_args_info.debug_given), optarg, 0, 0, ARG_INT,
              check_ambiguity, override, 0, 0,
              "debug", 'd',
              additional_error))
            goto failure;
        
          break;
        case 'D':	/* Enable floating point exceptions..  */
        
        
          if (update_arg((void *)&(args_info->debug_fpe_flag), 0, &(args_info->debug_fpe_given),
              &(local_args_info.debug_fpe_given), optarg, 0, 0, ARG_FLAG,
              check_ambiguity, override, 1, 0, "debug-fpe", 'D',
              additional_error))
            goto failure;
        
          break;
        case 'q':	/* Disable event counter..  */
        
        
          if (update_arg((void *)&(args_info->quiet_flag), 0, &(args_info->quiet_given),
              &(local_args_info.quiet_given), optarg, 0, 0, ARG_FLAG,
              check_ambiguity, override, 1, 0, "quiet", 'q',
              additional_error))
            goto failure;
        
          break;
        case 'j':	/* Number of jobs to run in parallel..  */
        
        
          if (update_arg( (void *)&(args_info->jobs_arg), 
               &(args_info->jobs_orig), &(args_info->jobs_given),
              &(local_args_info.jobs_given), optarg, 0, 0, ARG_INT,
              check_ambiguity, override, 0, 0,
              "jobs", 'j',
              additional_error))
            goto failure;
        
          break;
        case 'x':	/* An input file to modify run parameters..  */
        
        
          if (update_arg( (void *)&(args_info->setupfile_arg), 
               &(args_info->setupfile_orig), &(args_info->setupfile_given),
              &(local_args_info.setupfile_given), optarg, 0, 0, ARG_STRING,
              check_ambiguity, override, 0, 0,
              "setupfile", 'x',
              additional_error))
            goto failure;
        
          break;
        case 'c':	/* Matchbox cache directory..  */
        
        
          if (update_arg( (void *)&(args_info->cachedir_arg), 
               &(args_info->cachedir_orig), &(args_info->cachedir_given),
              &(local_args_info.cachedir_given), optarg, 0, "Herwig-cache", ARG_STRING,
              check_ambiguity, override, 0, 0,
              "cachedir", 'c',
              additional_error))
            goto failure;
        
          break;
        case 'z':	/* The number of subprocesses to integrate per job (build only)..  */
        
        
          if (update_arg( (void *)&(args_info->jobsize_arg), 
               &(args_info->jobsize_orig), &(args_info->jobsize_given),
              &(local_args_info.jobsize_given), optarg, 0, 0, ARG_LONG,
              check_ambiguity, override, 0, 0,
              "jobsize", 'z',
              additional_error))
            goto failure;
        
          break;
        case 'y':	/* The maximum number of integration jobs to be created (build only)..  */
        
        
          if (update_arg( (void *)&(args_info->maxjobs_arg), 
               &(args_info->maxjobs_orig), &(args_info->maxjobs_given),
              &(local_args_info.maxjobs_given), optarg, 0, 0, ARG_LONG,
              check_ambiguity, override, 0, 0,
              "maxjobs", 'y',
              additional_error))
            goto failure;
        
          break;
        case 'n':	/* Integrate the given integration job..  */
        
        
          if (update_arg( (void *)&(args_info->jobid_arg), 
               &(args_info->jobid_orig), &(args_info->jobid_given),
              &(local_args_info.jobid_given), optarg, 0, 0, ARG_STRING,
              check_ambiguity, override, 0, 0,
              "jobid", 'n',
              additional_error))
            goto failure;
        
          break;
        case 'i':	/* Append a search path for the read command..  */
        
          if (update_multiple_arg_temp(&append_read_list, 
              &(local_args_info.append_read_given), optarg, 0, 0, ARG_STRING,
              "append-read", 'i',
              additional_error))
            goto failure;
        
          break;
        case 'I':	/* Prepend a search path for the read command..  */
        
          if (update_multiple_arg_temp(&prepend_read_list, 
              &(local_args_info.prepend_read_given), optarg, 0, 0, ARG_STRING,
              "prepend-read", 'I',
              additional_error))
            goto failure;
        
          break;
        case 'l':	/* Append a search path for dynamically loaded libraries..  */
        
          if (update_multiple_arg_temp(&append_list, 
              &(local_args_info.append_given), optarg, 0, 0, ARG_STRING,
              "append", 'l',
              additional_error))
            goto failure;
        
          break;
        case 'L':	/* Prepend a search path for dynamically loaded libraries..  */
        
          if (update_multiple_arg_temp(&prepend_list, 
              &(local_args_info.prepend_given), optarg, 0, 0, ARG_STRING,
              "prepend", 'L',
              additional_error))
            goto failure;
        
          break;

        case 0:	/* Long option with no short option */
          if (strcmp (long_options[option_index].name, "full-help") == 0) {
            cmdline_parser_print_full_help ();
            cmdline_parser_free (&local_args_info);
            exit (EXIT_SUCCESS);
          }

          /* Repository file to use..  */
          if (strcmp (long_options[option_index].name, "repo") == 0)
          {
          
          
            if (update_arg( (void *)&(args_info->repo_arg), 
                 &(args_info->repo_orig), &(args_info->repo_given),
                &(local_args_info.repo_given), optarg, 0, "HerwigDefaults.rpo", ARG_STRING,
                check_ambiguity, override, 0, 0,
                "repo", '-',
                additional_error))
              goto failure;
          
          }
          /* If set, ThePEG will not try to recover from failures, but will exit with a non-zero return code..  */
          else if (strcmp (long_options[option_index].name, "noexitonerror") == 0)
          {
          
          
            if (update_arg((void *)&(args_info->noexitonerror_flag), 0, &(args_info->noexitonerror_given),
                &(local_args_info.noexitonerror_given), optarg, 0, 0, ARG_FLAG,
                check_ambiguity, override, 1, 0, "noexitonerror", '-',
                additional_error))
              goto failure;
          
          }
          /* Try to resume execution from an earlier interrupted run..  */
          else if (strcmp (long_options[option_index].name, "resume") == 0)
          {
          
          
            if (update_arg((void *)&(args_info->resume_flag), 0, &(args_info->resume_given),
                &(local_args_info.resume_given), optarg, 0, 0, ARG_FLAG,
                check_ambiguity, override, 1, 0, "resume", '-',
                additional_error))
              goto failure;
          
          }
          
          break;
        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          goto failure;

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c%s\n", CMDLINE_PARSER_PACKAGE, c, (additional_error ? additional_error : ""));
          abort ();
        } /* switch */
    } /* while */


  update_multiple_arg((void *)&(args_info->append_read_arg),
    &(args_info->append_read_orig), args_info->append_read_given,
    local_args_info.append_read_given, 0,
    ARG_STRING, append_read_list);
  update_multiple_arg((void *)&(args_info->prepend_read_arg),
    &(args_info->prepend_read_orig), args_info->prepend_read_given,
    local_args_info.prepend_read_given, 0,
    ARG_STRING, prepend_read_list);
  update_multiple_arg((void *)&(args_info->append_arg),
    &(args_info->append_orig), args_info->append_given,
    local_args_info.append_given, 0,
    ARG_STRING, append_list);
  update_multiple_arg((void *)&(args_info->prepend_arg),
    &(args_info->prepend_orig), args_info->prepend_given,
    local_args_info.prepend_given, 0,
    ARG_STRING, prepend_list);

  args_info->append_read_given += local_args_info.append_read_given;
  local_args_info.append_read_given = 0;
  args_info->prepend_read_given += local_args_info.prepend_read_given;
  local_args_info.prepend_read_given = 0;
  args_info->append_given += local_args_info.append_given;
  local_args_info.append_given = 0;
  args_info->prepend_given += local_args_info.prepend_given;
  local_args_info.prepend_given = 0;
  
  if (check_required)
    {
      error_occurred += cmdline_parser_required2 (args_info, argv[0], additional_error);
    }

  cmdline_parser_release (&local_args_info);

  if ( error_occurred )
    return (EXIT_FAILURE);

  if (optind < argc)
    {
      int i = 0 ;
      int found_prog_name = 0;
      /* whether program name, i.e., argv[0], is in the remaining args
         (this may happen with some implementations of getopt,
          but surely not with the one included by gengetopt) */

      i = optind;
      while (i < argc)
        if (argv[i++] == argv[0]) {
          found_prog_name = 1;
          break;
        }
      i = 0;

      args_info->inputs_num = argc - optind - found_prog_name;
      args_info->inputs =
        (char **)(malloc ((args_info->inputs_num)*sizeof(char *))) ;
      while (optind < argc)
        if (argv[optind++] != argv[0])
          args_info->inputs[ i++ ] = gengetopt_strdup (argv[optind-1]) ;
    }

  return 0;

failure:
  free_list (append_read_list, 1 );
  free_list (prepend_read_list, 1 );
  free_list (append_list, 1 );
  free_list (prepend_list, 1 );
  
  cmdline_parser_release (&local_args_info);
  return (EXIT_FAILURE);
}
/* vim: set ft=c noet ts=8 sts=8 sw=8 tw=80 nojs spell : */
